	<div id="bldDesigner" class="dialog hidden">
		<a href="javascript:void(0);" class="close" title="Close">X</a>
			<legend>Building Designer</legend>
			<fieldset>
				<? /*  TODO:
				--need an image library dialog 
					(store images for this building in the database and abstract the filenames)
				--YARR-neighbor selector
				--2d multi-point selector
				--YAAA-color picker
				--DONE-update the spin control
				*/ ?>
				<label>Type:
					<select class="bldType">
						<option value="sprite">Sprite</option>
						<option value="groundImg">Ground Covering</option>
						<option value="building">Building</option>
					</select>
				</label>

				<div class="sectSprite">
					<label>Image Source:
						<input type="text" class="bldSprite" value="">
						<a href="javascript:void(0);" class="imgSel">...</a>
					</label>
				</div>

				<div class="sectGround hidden">
					<label>Friends:
						<span class="note">Comma separated list of building IDs that match as neighbors</span>
						<input type="text" class="friends" value="">
					</label>
					<h2><button class="addNeighbor">Add Neighbor</button>Neighbors</h2>
					<ul class="neighbors items">
						<li class="template hidden">
							<button class="delParent">Delete</button>
							<label>Neighbors:
								<input type="hidden" class="neighbor_selector">
							</label>
							<label>Image Source:
								<input type="text" class="neighborImg" value="">
								<a href="javascript:void(0);" class="imgSel">...</a>
							</label>
						</li>
					</ul>
					<label>Allow Bridges:
						<input type="checkbox" class="allowBridges">
					</label>
					<div class="bridgesAllowed hidden">
						<h2><button class="addBridgeSide">Add Bridge Side</button>Bridge Sides</h2>
						<ul class="bridgeSides items">
							<li class="template hidden">
								<button class="delParent">Delete</button>
								<label>Relation:
									<span class="note">JavaScript expression to be evaluated. <code>bridgeTileIndex</code> and <code>bridgeLength</code> variables can be used determine which piece of the bridge to select.</span>
									<input type="text" class="brsdRel" value="">
									<ul class="brsdRelCommon">
										<li><a href="javascript:void(0);" class="brsdRelCommon" rel="bridgeTileIndex!=0 && bridgeTileIndex!=bridgeLength-1">Anything but edges</a></li>
										<li><a href="javascript:void(0);" class="brsdRelCommon" rel="bridgeTileIndex==0 || bridgeTileIndex==bridgeLength-1">Only edges</a></li>
									</ul>
								</label>
								<label>Height:
									<input type="text" class="brsdHeight spin no_negative no_zero by_tenths" value="0.5">
								</label>
								<label>Vertical Offset:
									<input type="text" class="brsdVertOffset spin by_tenths" value="0">
								</label>
								<label>Image Source:
									<input type="text" class="brsdImage" value="">
									<a href="javascript:void(0);" class="imgSel">...</a>
								</label>
								<label>Backside Image Source:
									<input type="text" class="brsdBehindImage" value="">
									<a href="javascript:void(0);" class="imgSel">...</a>
								</label>
							</li>
						</ul>
					</div>
				</div>
				
				<div class="sectBuilding hidden">
					<label>Size:
						<input type="text" class="bldSize spin no_zero no_negative" value="1">
					</label>
					<label>Use Custom Box Draw Order
						<input type="checkbox" class="boxOrder">
					</label>
					<div class="sectBoxOrder hidden">
						<label>Rotation 0:
							<span class="note">Comma separated list of box indexes</span>
							<input type="text" class="boxOrderRot0">
						</label>
						<label>Rotation 1:
							<span class="note">Comma separated list of box indexes</span>
							<input type="text" class="boxOrderRot1">
						</label>
						<label>Rotation 2:
							<span class="note">Comma separated list of box indexes</span>
							<input type="text" class="boxOrderRot2">
						</label>
						<label>Rotation 3:
							<span class="note">Comma separated list of box indexes</span>
							<input type="text" class="boxOrderRot3">
						</label>
					</div>
					<h2><button class="addBox">Add Box</button>Boxes</h2>
					<ul class="boxes items large">
						<li class="template hidden">
							<button class="delParent">Delete</button>
							<label>Altitude:
								<input type="text" class="boxAlt spin no_negative" value="0">
							</label>
							<label>Wall Color:
								<input type="text" class="boxColor color_picker" value="0,0,0,1">
							</label>
							<label>Don't Apply Shadows:
								<input type="checkbox" class="boxDontShadow">
							</label>
							<h2><button class="addFloor">Add Floor</button>Floors</h2>
							<ul class="floors items medium">
								<li class="template hidden">
									<button class="delParent">Delete</button>
									<button class="cloneParent">Clone</button>
									<label>ID:
										<span class="note">Specify to allow for this floor to have selectable repeating.</span>
										<input type="text" class="flrID" value="">
									</label>
									<label>Repeat:
										<input type="text" class="flrRepeat spin no_negative" value="1">
									</label>
									<label>Bottom:
										<input class="bottomPts">
									</label>
									<label>Top:
										<input class="topPts">
									</label>
									<label>Height:
										<input type="text" class="flrHeight spin no_negative" value="20">
									</label>
									<label>Don't Apply Shadows:
										<input type="checkbox" class="flrDontShadow">
									</label>
									<label>Wall Color:
										<input type="text" class="flrColor color_picker" value="0,0,0,1">
									</label>
									<h2><button class="addShape">Add Shape</button>Shapes</h2>
									<ul class="shapes items" data-side="0">
										<li class="template hidden">
											<button class="delParent">Delete</button>
											<button class="cloneParent">Clone</button>
											<label>Positions:
												<span class="note">Comma separated list of proportions for where to paint this shape. 0 corresponds to the left of this side, 1 with the right.</span>
												<input type="text" class="shpPos" value="">
											</label>
											<label>Altitude:
												<input type="text" class="shpAlt spin by_tenths" value="0">
											</label>
											<label>Height:
												<input type="text" class="shpHeight spin no_negative no_zero max_one by_tenths" value="0.5">
											</label>
											<label>Width:
												<input type="text" class="shpWidth spin no_negative no_zero max_one by_tenths" value="0.5">
											</label>
											<label>Type:
												<select class="shpType">
													<option value="image">Image</option>
													<option value="square">Square</option>
												</select>
											</label>
											<div class="sectShpImg">
												<label>ID:
													<span class="note">Specify to allow for this shape to have a customizable image.</span>
													<input type="text" class="shpID" value="">
												</label>
												<label>Image Source:
													<input type="text" class="shpImage" value="">
													<a href="javascript:void(0);" class="imgSel">...</a>
												</label>
											</div>
											<div class="sectShpSqr hidden">
												<label>Border Width:
													<input type="text" class="shpBorderWidth spin no_negative" value="1">
												</label>
												<label>Border Color:
													<input type="text" class="shpBorderColor color_picker" value="0,0,0,1">
												</label>
												<label>Fill Color:
													<input type="text" class="shpFillColor color_picker" value="0,0,0,1">
												</label>
											</div>
										</li>
									</ul>
								</li>
							</ul>
						</li>
					</ul>
				</div>
					
			</fieldset>
			<canvas id="bldView"></canvas>

	</div>
