jQuery(function($){
	$(".bldType").change(function(){
		switch(this.value){
			case "sprite":
				$(".sectSprite").removeClass("hidden");
				$(".sectGround").addClass("hidden");
				$(".sectBuilding").addClass("hidden");
				break;
			case "groundImg":
				$(".sectSprite").removeClass("hidden");
				$(".sectGround").removeClass("hidden");
				$(".sectBuilding").addClass("hidden");
				break;
			case "building":
				$(".sectSprite").addClass("hidden");
				$(".sectGround").addClass("hidden");
				$(".sectBuilding").removeClass("hidden");
				break;
		}
	});
	
	$(".boxOrder").change(function(){
		if($(this).attr('checked')){
			$(".sectBoxOrder").removeClass("hidden");
		}else{
			$(".sectBoxOrder").addClass("hidden");
		}
	});
	
	$(".shpType").change(function(){
		var cShp=$(this).closest('li');
		switch(this.value){
			case "image":
				cShp.find('.sectShpImg').removeClass('hidden');
				cShp.find('.sectShpSqr').addClass('hidden');
				break;
			case "square":
				cShp.find('.sectShpImg').addClass('hidden');
				cShp.find('.sectShpSqr').removeClass('hidden');
				break;
		}
	});
	
	$(".allowBridges").change(function(){
		if($(this).attr('checked')){
			$(".bridgesAllowed").removeClass("hidden");
		}else{
			$(".bridgesAllowed").addClass("hidden");
		}
	});
	
	$("a.brsdRelCommon").click(function(){
		$(this).closest('label').find('.brsdRel').val(
			$(this).attr('rel'));
	});
	
	$(".addNeighbor").click(function(){
		var newNeighbor=$(".neighbors>.template").clone().removeClass("template hidden");
		newNeighbor.find(".neighbor_selector").each(function(){
			initNeighborSel(this);
		});
		newNeighbor.appendTo(".neighbors")
	});
	
	$(".addBridgeSide").click(function(){
		$(".bridgeSides>.template").clone().removeClass("template hidden").appendTo(".bridgeSides");
	});
	
	$(".addBox").click(function(){
		$(".boxes>.template").clone().removeClass("template hidden").appendTo(".boxes");
	});

	$(".addFloor").live('click',function(){
		var newFloor=$(this).closest('li').find(".floors>.template").clone().removeClass("template hidden");
		newFloor.appendTo($(this).closest('li').find(".floors"));
	});
	$(".addShape").live('click',function(){
		var newShape=$(this).closest('li').find(".shapes>.template").clone().removeClass("template hidden");
		newShape.appendTo($(this).closest('li').find(".shapes"));
	});
	
	$(".delParent").live('click',function(){
		$(this).closest('li').remove();
	});
	$(".cloneParent").live('click',function(){
		$(this).closest('li').clone().insertAfter($(this).closest('li'));
	});
	

});
