/* TODO
	-fix rotation view centering
	-fix zoom view centering
*/

	
//runtime buffers
var mouse={x:0,y:0},
	flatMouse={x:0,y:0},
	sel={a:false,b:false,mouseIsDown:false},
	cursorMode=1,moveStart={x:0,y:0},
	offsetStart={x:0,y:0},
	viewSpeed={x:0,y:0},
	spaceBarDown=false,
	ctrlDown=false,
	shiftDown=false,
	tileWidthStart=0,
	zoomPoint,
	rotationStart=0,
	camHeightStart=0,
	viewAnimTimer,
	buildings=[],
	maps=[];



function refresh(clearNeighbors){
	var canvas = document.getElementById("game");
	/* did't work out as planned... */
	//if(clearNeighbors) removeImages("neighbor::");
	loadImages(buildings,rotation,cameraHeight);
	
	draw(map,mapOffset,rotation,showGrid,sel,mouse,tileWidth,canvas,cameraHeight,showDebug);
}


function makeMap(lenX,lenY,baseAlt){
	var output=[],
		curRow;
	for(var x=0;x<lenX;x++){
		curRow=[];
		for(var y=0;y<lenY;y++){
			curRow.push({alt:[baseAlt,baseAlt,baseAlt,baseAlt],water:false});
		}
		output.push(curRow);
	}
	return output;
}

function game_zoom(ev){
	var tileWidthStart=tileWidth,
		x, y;
		
	// Get the mouse position relative to the canvas element.
	if (ev.layerX || ev.layerX == 0) { // Firefox
		x = ev.layerX;
		y = ev.layerY;
	} else if (ev.offsetX || ev.offsetX == 0) { // Opera
		x = ev.offsetX;
		y = ev.offsetY;
	}
	
	if(ev.wheelDelta>0){
		//map zoom!
		tileWidth+=10;

		
	}else{
		tileWidth-=10;
	}
	//keep inbounds!
	tileWidth=Math.round(tileWidth < minZoom ? minZoom : (tileWidth > maxZoom ? maxZoom : tileWidth));
	//TODO:i dont think the next line actually does anything!
	if(tileWidth == NaN) tileWidth=minZoom;
	
	//center map 
	
	try{
		var tileIndex=cursorPos(x,y,map,rotation,tileWidthStart,mapOffset,cameraHeight)
		zoomPoint={pos:tilePos(tileIndex.x,tileIndex.y,map,rotation,tileWidthStart,mapOffset,cameraHeight,false),tile:tileIndex};
		offsetStart.x=mapOffset.x;
		offsetStart.y=mapOffset.y;
		//center map 
		var newPos=tilePos(zoomPoint.tile.x,zoomPoint.tile.y,map,rotation,tileWidth,offsetStart,cameraHeight,false);
		var xDiff=newPos[0].x-zoomPoint.pos[0].x,
			yDiff=newPos[0].y-zoomPoint.pos[0].y;
	
		mapOffset.x=offsetStart.x-xDiff;
		mapOffset.y=offsetStart.y-yDiff;
	}catch(err){}
	/*
	var diff=tileWidth-tileWidthStart;
	mapOffset.x=mapOffset.x-(12*diff);
	mapOffset.y=mapOffset.y-(2*diff);*/
	refresh(true);
}


function game_mousemove(ev){
	var x, y;

	// Get the mouse position relative to the canvas element.
	if (ev.layerX || ev.layerX == 0) { // Firefox
		x = ev.layerX;
		y = ev.layerY;
	} else if (ev.offsetX || ev.offsetX == 0) { // Opera
		x = ev.offsetX;
		y = ev.offsetY;
	}
	flatMouse={x:x,y:y};

	//select tiles
	mouse=cursorPos(x,y,map,rotation,tileWidth,mapOffset,cameraHeight);
	
	
	if(sel.mouseIsDown && ctrlDown){
		//adjust camera height
		cameraHeight=camHeightStart+((moveStart.y-y)/200);
		cameraHeight=(cameraHeight < minCamH ? minCamH : (cameraHeight > maxCamH ? maxCamH : cameraHeight));
		refresh(true);

	}else if(sel.mouseIsDown && spaceBarDown==false){
		//only redraw if we're on the board
		if(mouse){
			sel.b=mouse;
			
			//callback the ui
			selUpdated();
		}
		
	}else if(spaceBarDown==true){
	
		if(viewAnimTimer)
			clearTimeout(viewAnimTimer);

		//move view
		viewSpeed.x=(viewSpeed.x+(3*(mapOffset.x-(offsetStart.x-(moveStart.x-x)))))/3;
		viewSpeed.y=(viewSpeed.y+(3*(mapOffset.y-(offsetStart.y-(moveStart.y-y)))))/3;
		mapOffset.x=offsetStart.x-(moveStart.x-x);
		mapOffset.y=offsetStart.y-(moveStart.y-y);
		
	}
	refresh();

}

function rotateView(amount,x,y){
	
	//map rotate!
	origRotation=rotation;
	rotation+=amount;
	if(rotation>3) rotation=0;
	if(rotation<0) rotation=3;
	
	try{
		var tileIndex=cursorPos(x,y,map,origRotation,tileWidth,mapOffset,cameraHeight),
			zoomPoint={pos:tilePos(tileIndex.x, tileIndex.y, map, origRotation, tileWidth, mapOffset, cameraHeight, false),
						tile:tileIndex};
		offsetStart.x=mapOffset.x;
		offsetStart.y=mapOffset.y;
		//center map 
		var newPos=tilePos(zoomPoint.tile.x,zoomPoint.tile.y,map,rotation,tileWidth,offsetStart,cameraHeight,false);
		var xDiff=newPos[0].x-zoomPoint.pos[0].x,
			yDiff=newPos[0].y-zoomPoint.pos[0].y;
	
		mapOffset.x=offsetStart.x-xDiff;
		mapOffset.y=offsetStart.y-yDiff;
	}catch(err){}
	spaceBarDown=false;
	refresh(true);
}


function game_mousedown(ev){
	var x, y;

	if(ev.button==2) return false;
	// Get the mouse position relative to the canvas element.
	if (ev.layerX || ev.layerX == 0) { // Firefox
		x = ev.layerX;
		y = ev.layerY;
	} else if (ev.offsetX || ev.offsetX == 0) { // Opera
		x = ev.offsetX;
		y = ev.offsetY;
	}
	if(ctrlDown){
		camHeightStart=cameraHeight;
		moveStart.y=y;
		sel.mouseIsDown=true;
	}else if(spaceBarDown){
		rotateView(1,x,y);
		
	}else if(spaceBarDown==false){
		//select tiles
		sel.a=cursorPos(x,y,map,rotation,tileWidth,mapOffset,cameraHeight);
		sel.b=cursorPos(x,y,map,rotation,tileWidth,mapOffset,cameraHeight);
		//only redraw if we're on the board
		if(sel.a) {
			sel.mouseIsDown=true;
			refresh();
			selUpdated();
		}

	}

}

function game_mouseup(ev){
	var x, y;

	// Get the mouse position relative to the canvas element.
	if (ev.layerX || ev.layerX == 0) { // Firefox
		x = ev.layerX;
		y = ev.layerY;
	} else if (ev.offsetX || ev.offsetX == 0) { // Opera
		x = ev.offsetX;
		y = ev.offsetY;
	}

	if(ctrlDown){
		//adjust camera height
		cameraHeight=camHeightStart+(Math.round((moveStart.y-y)/2)/100);
		cameraHeight=(cameraHeight < minCamH ? minCamH : (cameraHeight > maxCamH ? maxCamH : cameraHeight));
		refresh(true);
		sel.mouseIsDown=false;

	}else if(spaceBarDown==false){
		//select tiles
		sel.mouseIsDown=false;
		refresh();

	}

}

function animateView(x,y){
	if(Math.abs(x)>10 || Math.abs(y)>10){
		mapOffset.x-=(x/3);
		mapOffset.y-=(y/3);
		refresh();
		viewAnimTimer=setTimeout("animateView("+Math.round(2*x/3)+","+Math.round(2*y/3)+");",70);
	}
}

function animateViewNOTFUCKINGWORKING(x,y){
	var canvas = document.getElementById("game"),
		corners=[tilePos(0,0,map,rotation,tileWidth,mapOffset,cameraHeight),
				 tilePos(0,map[0].length-1,map,rotation,tileWidth,mapOffset,cameraHeight),
				 tilePos(map.length-1,map[0].length-1,map,rotation,tileWidth,mapOffset,cameraHeight),
				 tilePos(map.length-1,0,map,rotation,tileWidth,mapOffset,cameraHeight)],
		whichCorners=[rotation,
					  (rotation+1>3 ? rotation-3 : rotation+1),
					  (rotation+2>3 ? rotation-2 : rotation+2),
					  (rotation+3>3 ? rotation-1 : rotation+3)],
		drawCorners=[corners[whichCorners[0]][whichCorners[0]].x,
						corners[whichCorners[1]][whichCorners[1]].y,
						corners[whichCorners[2]][whichCorners[2]].x,
						corners[whichCorners[3]][whichCorners[3]].y];
				
	if((((drawCorners[0]>0 && drawCorners[0]<canvas.width) || 
			(drawCorners[2]>0 && drawCorners[2]<canvas.width)) &&
		((drawCorners[1]>0 && drawCorners[1]<canvas.height) || 
			(drawCorners[3]>0 && drawCorners[3]<canvas.height))) &&
		(Math.abs(x)>10 || Math.abs(y)>10))
	{
		mapOffset.x-=(x/3);
		mapOffset.y-=(y/3);
		refresh();
		viewAnimTimer=setTimeout("animateView("+Math.round(2*x/3)+","+Math.round(2*y/3)+");",70);
	}
}

function game_keydown(ev){
	if(ev.keyCode==32) {
		//space bar
		if(!spaceBarDown){
			var canvas = document.getElementById("game");
			canvas.style.cursor="move";

			//move view
			moveStart.x=flatMouse.x;
			moveStart.y=flatMouse.y;
			offsetStart.x=mapOffset.x;
			offsetStart.y=mapOffset.y;
			spaceBarDown=true;
		}


	}
	if(ev.keyCode==17) {
		tileWidthStart=tileWidth;
		ctrlDown=true;
	}
	if(ev.keyCode==16) {
		rotStart=rotation;
		shiftDown=true;
	}

}
function game_keyup(ev){
	if(ev.keyCode==	32) {
		//space bar
		var canvas = document.getElementById("game");
		canvas.style.cursor="";
		spaceBarDown=false;
		animateView(viewSpeed.x,viewSpeed.y);

	}
	if(ev.keyCode==17) {
		ctrlDown=false;
	}
	if(ev.keyCode==16) {
		shiftDown=false;
	}
	
}

function game_contextmenu(ev){
	var x, y;
	ev.preventDefault();

	// Get the mouse position relative to the canvas element.
	if (ev.layerX || ev.layerX == 0) { // Firefox
		x = ev.layerX;
		y = ev.layerY;
	} else if (ev.offsetX || ev.offsetX == 0) { // Opera
		x = ev.offsetX;
		y = ev.offsetY;
	}
	
	
	//fucking contextmenu jquery offset call takes 1 sec to go?!? and causes some
	//error that doesnt get logged?!?! wtf?!?!?!?
	//showContextMenu(x,y);
	//continue with old style ui----
	if(spaceBarDown){
		rotateView(-1,x,y);
	}else{
		centerView(x,y);
	}
	
	return false;
}

function centerView(x,y){
	var canvas = document.getElementById("game"),
		deltaX=x-(canvas.width/2),
		deltaY=y-(canvas.height/2);
	
	if(viewAnimTimer)
		clearTimeout(viewAnimTimer);
	
	animateView(deltaX,deltaY);
}


function onLoad() {
	var canvas = document.getElementById("game");
	canvas.addEventListener('mousemove', game_mousemove, false);
	canvas.addEventListener('mousedown', game_mousedown, false);
	canvas.addEventListener('mouseup', game_mouseup, false);
	window.addEventListener('keydown', game_keydown, true);
	window.addEventListener('keyup', game_keyup, true);
	canvas.addEventListener('mousewheel', game_zoom, false);
	canvas.addEventListener('contextmenu', game_contextmenu, true);
	fixWater(map);
	refresh();
}
//TODO: is addEventListener not how its done in M$-land?
// Keep everything in anonymous function, called on window load.
if(window.addEventListener) {
	window.addEventListener('load', onLoad,false);
}
