jQuery(function($){
	$(".color_picker").each(function(){
		initColorPicker(this);
	});
});

function initColorPicker(element){
	var $e=$(element),
		colorSpl=$e.val().split(",");
		newSel=$('<div class="colorPicker"><div class="colorSel"><label><span>Red:</span><input type="text" class="red spin no_negative max" data-max="255" value="'+colorSpl[0]+'"></label><label><span>Green:</span><input type="text" class="green spin no_negative max" data-max="255" value="'+colorSpl[1]+'"></label><label><span>Blue:</span><input type="text" class="blue spin no_negative max" data-max="255" value="'+colorSpl[2]+'"></label><label><span>Alpha:</span><input type="text" class="alpha spin no_negative max_one by_tenths" value="'+colorSpl[3]+'"></label></div></div>');
	
	//read the initial color
	newSel.css('background',"rgb("+colorSpl[0]+','+colorSpl[1]+','+colorSpl[2]+")");
	
	$e.change(function(){
		var colorSpl=this.value.split(',');
			colorPicker=$(this).parent().parent().find(".colorPicker");
		colorPicker.css('background',"rgb("+colorSpl[0]+','+colorSpl[1]+','+colorSpl[2]+")");
		colorPicker.find(".red").val(colorSpl[0]);
		colorPicker.find(".green").val(colorSpl[1]);
		colorPicker.find(".blue").val(colorSpl[2]);
		colorPicker.find(".alpha").val(colorSpl[3]);
	});
	
	newSel.find(".spin").each(function(){
		$(this).change(function(){
		//update the color on the colorPicker and the input's value
		var $this=$(this),
			colorPicker=$this.closest(".colorPicker"),
			origInput=colorPicker.parent().find(".color_picker");
			red=parseInt(colorPicker.find("input.red").val()),
			green=parseInt(colorPicker.find("input.green").val()),
			blue=parseInt(colorPicker.find("input.blue").val()),
			alpha=parseFloat(colorPicker.find("input.alpha").val());
		
		colorPicker.css("background","rgb("+red+','+green+','+blue+")");
		origInput.val(red+','+green+','+blue+','+alpha);
			
		});
		initSpin(this);
	});
	
	$e.parent().parent().prepend(newSel);
}
