/*jQuery(function($){
	$(".neighbor_selector").each(function(){
		initNeighborSel(this);
	});
	
});*/

function initNeighborSel(element){
	var $e=$(element),
		curVal=$e[0].value.split(",");
	$e.before('<a class="addNeighborSel" href="javascript:void(0);">Add Neighor Selector</a>');
	
	for(var i=0;i<curVal.length;i++){
		addNeighborSel($e.parent().children(".addNeighborSel"),curVal[i]);
	}
	
	$e.parent().children(".addNeighborSel").click(function(){
		addNeighborSel(this,"000000000");
		updateSelString($(this).parent());
	});
}

function addNeighborSel(element,value){
	var curSel=[];
	for(var i=0;i<9;i++){
		if(value.substr(i,1)=="1"){
			curSel.push(" sel");
		}else{
			curSel.push("");
		}
	}
	
	var $e=$(element);
		newSel=$('<div class="neighborSel"><div class="n0'+curSel[0]+'"></div><div class="n1'+curSel[1]+'"></div><div class="n2'+curSel[2]+'"></div><div class="n3'+curSel[3]+'"></div><div class="n4'+curSel[4]+'"></div><div class="n5'+curSel[5]+'"></div><div class="n6'+curSel[6]+'"></div><div class="n7'+curSel[7]+'"></div><div class="n8'+curSel[8]+'"></div><a href="javascript:void(0);" class="removeNeighborSel">Remove</a></div>');
	
	newSel.children("div").click(function(){
		var $this=$(this),
			cLabel=$this.parent().parent();

		//don't do anything on the center tile
		if($this.hasClass("n4")) return false;
		
		//toggle tile
		if($this.hasClass("sel"))
			$this.removeClass("sel");
		else $this.addClass("sel");
		
		//build the neighbor string
		updateSelString(cLabel);
		
	});
	newSel.children(".removeNeighborSel").click(function(){
		var $this=$(this),
			cLabel=$this.parent().parent();

		$this.parent().remove();
		
		//build the neighbor string
		updateSelString(cLabel);
		
	});
	
	newSel.insertBefore($e);
}

function updateSelString(cLabel){
	var selStr="";
	cLabel.children(".neighborSel").each(function(){
		var cSel="";
		$(this).children().each(function(){
			if($(this).hasClass("sel"))
				cSel+="1";
			else cSel+="0";
		});
		selStr+=cSel+',';
	});
	
	if(selStr.substr(selStr.length-1)==",")
		selStr=selStr.substr(0,selStr.length-1);
	
	cLabel.children(".neighbor_selector").val(selStr);
}
