var curSpin,spinDown=false,curSpinTimer;

jQuery(function($){
	$(".spin").each(function(){
		initSpin(this);
	});
	
	$(".spin_up").live('mousedown',function(){
		clearTimeout(curSpinTimer);
		curSpin=$(this).prev();
		spinDown=true;
		spin(1);
	}).live('mouseup mouseout',function(){
		spinDown=false;
	});
	$(".spin_down").live('mousedown',function(){
		clearTimeout(curSpinTimer);
		curSpin=$(this).prev().prev();
		spinDown=true;
		spin(-1);
	}).live('mouseup mouseout',function(){
		spinDown=false;
	});
});

function initSpin(element){
	$(element).after('<a class="spin_btn spin_up">+</a><a class="spin_btn spin_down">-</a>');
}

function spin(amount){
	if(spinDown){
		var input=curSpin;
		if(input.hasClass('by_tenths')){
			input[0].value=parseInt((input[0].value*10)+amount)/10;
		}else{
			input[0].value=parseInt(input[0].value)+amount;
		}

		
		
		if(input.hasClass('no_zero') && input[0].value==0){
			if(input.hasClass('by_tenths'))
				input[0].value=0.1;
			else input[0].value=(amount>0 ? 1 : -1);
		}
		if(input.hasClass('no_negative') && input[0].value<0)
			input[0].value=0;
		if(input.hasClass('max_one') && input[0].value>1)
			input[0].value=1;
		if(input.hasClass('max') && input[0].value>parseInt(input.attr("data-max")))
			input[0].value=parseInt(input.attr("data-max"));
		if(input.hasClass('no_negative') && input.hasClass('no_zero') && input[0].value==0)
			input[0].value=1;
		curSpinTimer=setTimeout("spin("+amount+");",100);
		input.change();
	}
}

