jQuery(function($){
	$(".point_selector").each(function(){
		initPointSel(this);
	});
});

function initPointSel(element){
	var $e=$(element);
	$e.before('<ul class="pointList"></ul><a href="javascript:void(0);" class="addPoint">Add Point</a>');
	
	$e.parent().children(".pointList").sortable({ axis: 'y',stop:function(event,ui){
		$(this).children(".ui-sortable-placeholder").remove();
	} });
	$e.parent().children(".addPoint").click(function(){
		var $pl=$(this).prev(),
			newPoint=$('<li><input class="point" value="0,0"><a href="javascript:void(0);" class="delPoint">Delete</a></li>');
			
		newPoint.find("input").change(function(){
				updatePointString($(this).closest('label'));
				});
		$pl.append(newPoint).sortable('refresh');
		updatePointString($(this).parent());
	});
}

function updatePointString(element){
	var output='';
	
	$(element).find(".pointList li input").each(function(){
		output+=this.value+":";
	});
	
	if(output.substr(output.length-1)==":")
		output=output.substr(0,output.length-1);
	
	$(element).children(".point_selector").val(output);
	
}

