
var sessionID=0,availableMaps={};


function selUpdated(){
	var output='',
		params=listAvailableParams(map,sel);
	if(params.length){
		for(var i=0;i<params.length;i++){
			output+='<option value="'+params[i].id+':-:'+params[i].type+':-:'+params[i].val+'">'+params[i].id+'</option>';
		}
		$("#bldParamPanel").removeClass("hidden");
	}else{
		output="<option>...</option>";
		$("#bldParamPanel").addClass("hidden");
	}
	$("#bldParam").html(output).change(function(){
		var paramInfo=$(this).val().split(":-:"),
			paramVal=$("#bldParamVal");
		paramVal.attr('data-max','')
		paramVal.removeClass()
		paramVal.addClass(paramInfo[1]);
		paramVal.val(paramInfo[2]);
		
		//remove current controls
		paramVal.parent().parent().find(".spin_btn,.colorPicker,.browseMedia").remove();
		
		//add in the current controls
		switch(paramInfo[1]){
			case 'rotation':
				paramVal.addClass("spin max no_negative").attr("data-max","3");
				initSpin(paramVal);
				break;
			case 'floors':
				paramVal.addClass("spin no_negative");
				initSpin(paramVal);
				break;
			case 'color':
				paramVal.addClass("color_picker");
				initColorPicker(paramVal);
				break;
			case 'img':
				paramVal.parent().parent().prepend('<a href="javascript:showMediaSel();" class="browseMedia" title="Browse for Image">Browse for Image</a>');
				break;
		}
	}).change();
}

function showMediaSel(){
	$("#mediaMan").addClass('browser');
	showDialog($("#mediaMan"));

}


function showBuildingConts(id){
	$("#bldInfo .contents").val('Loading...');
	loadItem(id,function(data){
			if(data){
				$("#bldInfo .contents").val(data);
			}
	});
	showDialog($("#bldInfo"));
}

function insertBuilding(id){
	placeBuilding(map,sel.a.x,sel.a.y,id);
	refresh();

}

function showDialog(e){
	$(".dialog").css("zIndex","100");
	$(e).css("zIndex","1000").removeClass("hidden").draggable({
			cursor:'move',
			stack: ".dialog",
			containment: "window"
		});
};

function hideContextMenu(){
	$("#contextMenu").addClass("hidden");
}

function showContextMenu(x,y){
	var $menu=$("#contextMenu"),
		gamePos=$("#game").offset();
	$menu.removeClass("hidden");
	$menu.find("a").click(function(){
		hideContextMenu();
	});
	$menu.find(".centerMap").attr("href","javascript:centerView("+x+","+y+");");
	$menu.find(".rotateLeft").attr("href","javascript:rotateView(1,"+x+","+y+");");
	$menu.find(".rotateRight").attr("href","javascript:rotateView(-1,"+x+","+y+");");
	
	gamePos.top+=y;
	gamePos.left+=x;
	if(gamePos.top+$menu.height()>$(window).height()) gamePos.top-=$menu.height();
	if(gamePos.left+$menu.width()>$(window).width()) gamePos.left-=$menu.width();
	
	//TODO:what the fuck is up with this line of code?
	$menu.offset({'top':gamePos.top,'left':gamePos.left});
	console.log("done!");
}


jQuery(function($){
	function updateSplit(){
		var $this=$(this),
			winWidth=$(window).width(),
			newWidth=parseInt($this.css('left').replace("px","")),
			canvas = document.getElementById("game");
		if(newWidth<80) newWidth=80;
		if(newWidth>winWidth-80) newWidth=winWidth-80;
		$this.css('left',newWidth);
		$("#controls").width(newWidth-10);
		canvas.width =winWidth-newWidth;
		$(canvas).css("left",newWidth);
		refresh();
	};
	

	$("menu .login").click(function(e){
		e.preventDefault();
		if(sessionID==0){
			showDialog($("#login"));
		}else{
			setMapList();

			showDialog($("#mapMan"));
		};
	});
	$("menu .bldman").click(function(e){
		e.preventDefault();
		if(sessionID==0){
			showDialog($("#login"));
		}else{

			showDialog($("#bldMan"));
		};
	});
	$("menu .catman").click(function(e){
		e.preventDefault();
		loadBldCatList();
			
	});
	$("menu .mediaman").click(function(e){
		e.preventDefault();
		$("#mediaMan").removeClass('browser');
		showDialog($("#mediaMan"));
			
	});
	$(".dialog").live("click",function(){
		$(this).css("zIndex","1000");
	});

	$(".dialog .close").live("click",function(){
		$(this).parent().addClass("hidden");
	});

	$("#login .signup").click(function(){
		showDialog($("#signup"));
	});

	$("#login").submit(function(e){
		e.preventDefault();
		$("#login").addClass("loading");
		
		logIn($("#login input[name=name]").val(),
			  $("#login input[name=password]").val(),
				function(data){
					if(data==="fail"){
						$("#login").addClass("error").removeClass("loading");
					}else{
						$("nav .welcome").html("Welcome "+sessionID[0]).attr("data-user_id",sessionID[1]);
						$("#login").addClass("hidden").removeClass("loading");
						$("menu").removeClass("hidden");
						reloadContent();

					}
				}
			);
	});
	
	$("#signup form").submit(function(e){
		e.preventDefault();
		$("#signup").addClass("loading");
		
		signUp($("#signup input[name=name]").val(),
			   $("#signup input[name=password]").val(),
			   $("#signup input[name=email]").val(),
				function(data){
					if(data==="name in use"){
						$("#signup").addClass("error").removeClass("loading");
					}else if(data=="ok"){
						$("#signup").addClass("hidden").removeClass("loading");
					}
				}
			);
	});
	
	$("#mapMan form").submit(function(e){
		e.preventDefault();
		$("#mapMan").addClass("loading");
		
		saveItem($("#mapMan input[name=name]").val(),
				 typeCity,
				 $("#mapMan select[name=category]").val(),
				 $("#mapMan select[name=public]").val(),
				 $("#mapMan select[name=over]").val(),
				 JSON.stringify(map),
				 function(data){
					 if(data==="name in use"){
						$("#mapMan").addClass("error").removeClass("loading")
							.find(".error_msg").html("Name In Use!");
					}else if(data==="not logged in"){
						$("#mapMan").addClass("error").removeClass("loading")
							.find(".error_msg").html("Not Logged In");
					}else if(data==="already exists"){
						$("#mapMan").addClass("error").removeClass("loading")
							.find(".error_msg").html("Duplicate Name");
					}else if(data=="ok"){
						$("#mapMan").addClass("hidden").removeClass("loading error");
						setMapList();
					}
				 }
			);
		
	
	});
	
	$("#catMan form").submit(function(e){
		e.preventDefault();
		$("#catMan").addClass("loading");
		
		saveCat($("#catMan input[name=name]").val(),
				 $("#catMan input[name=parent_id]").val(),
				 $("#catMan input[name=type_id]").val(),
				 function(data){
					 if(data==="name in use"){
						$("#catMan").addClass("error").removeClass("loading")
							.find(".error_msg").html("Name In Use!");
					}else if(data==="not logged in"){
						$("#catMan").addClass("error").removeClass("loading")
							.find(".error_msg").html("Not Logged In");
					}else if(data==="already exists"){
						$("#catMan").addClass("error").removeClass("loading")
							.find(".error_msg").html("Duplicate Name");
					}else if(data=="ok"){
						$("#catMan").addClass("hidden").removeClass("loading error");
						loadBldCatList();
						reloadContent();
					}
				 }
			);
		
	
	});
	
	$("#mediaMan .mediaItem .itemLink").live("click",function(){
		var $this=$(this);
		if($("#mediaMan").hasClass("browser")){
			$("#mediaMan input[name=selID]").val($this.closest("li").attr("data-id"));
		}
	});
	
	$("#mediaMan form").submit(function(e){
		e.preventDefault();
		if($("#mediaMan").hasClass("browser")){
			$("#mediaMan").addClass("hidden");
			var bldParamVal=$("#bldParamVal");
			if(bldParamVal.hasClass("img")) bldParamVal.val('db:'+$("#mediaMan input[name=selID]").val());
		}else{
			$("#mediaMan").addClass("loading");
			$.ajaxFileUpload({
					url:'server.php',
					secureuri:false,
					fileElementId:'fileToUpload',
					dataType: 'html',
					name: $("#mediaMan input[name=name]").val(),
					category: $("#mediaMan select[name=category]").val(),
					over: $("#mediaMan select[name=over]").val(),
					session_id: sessionID[2],
					success: function (data, status)
					{
						if(data==="name in use"){
						$("#mediaMan").addClass("error").removeClass("loading")
							.find(".error_msg").html("Name In Use!");
						}else if(data==="not logged in"){
							$("#mediaMan").addClass("error").removeClass("loading")
								.find(".error_msg").html("Not Logged In");
						}else if(data==="already exists"){
							$("#mediaMan").addClass("error").removeClass("loading")
								.find(".error_msg").html("Duplicate Name");
						}else if(data=="ok"){
							$("#mediaMan").addClass("error").removeClass("loading")
								.find(".error_msg").html("Sprite Inserted Successfully");
						}
					},
					error: function (data, status, e)
					{
						alert(e);
					}
			});
		}
		
	
	});
	
	$("#bldMan form").submit(function(e){
		e.preventDefault();
		$("#bldMan").addClass("loading");
		var bldName=$("#bldMan input[name=name]").val(),
			bldConts=$("#bldMan textarea[name=contents]").val();
		
		saveItem(bldName,
			 typeBld,
			 $("#bldMan select[name=category]").val(),
			 $("#bldMan select[name=public]").val(),
			 $("#bldMan select[name=over]").val(),
			 bldConts,
			 function(data){
				if(data==="name in use"){
					$("#bldMan").addClass("error").removeClass("loading")
						.find(".error_msg").html("Name In Use!");
				}else if(data==="not logged in"){
					$("#bldMan").addClass("error").removeClass("loading")
						.find(".error_msg").html("Not Logged In");
				}else if(data==="already exists"){
					$("#bldMan").addClass("error").removeClass("loading")
						.find(".error_msg").html("Duplicate Name");
				}else if(data=="ok"){
					var bldIndex=getBuildingIndex(bldName);
					
					//refresh the current item
					if(bldIndex!==false){
						buildings[bldIndex]=eval('('+bldConts+')');
					}else{
						buildings.push(eval('('+bldConts+')'));
					}
					
					loadBuildingList();
				}
			
			}
		);
		

	});

	$("#splitter").draggable({axis:'x',drag:updateSplit,stop:updateSplit});
	$(".control>a").click(function(e){
		e.preventDefault();
		$(this).parent().toggleClass('minimize');
	});
	
	$("#apply_params").click(function(e){
		var paramInfo=$("#bldParam").val().split(":");
		e.preventDefault();
		paramOnSel(map,sel,paramInfo[0],$("#bldParamVal").val(),rotation,cameraHeight);
		selUpdated();
	});
	
	$("#new_map").click(function(e){
		e.preventDefault();
		map=makeMap(parseInt($("#newMapX").val()),parseInt($("#newMapY").val()),parseInt($("#newMapAlt").val()));
		refresh();
	});

	$("#change_alt").click(function(e){
		e.preventDefault();
		changeAltitude(map,sel,parseInt($("#altChange").val()),($("#altEdges")[0].value!="" ? true :false),minAlt,maxAlt);
		refresh();
	});

	
	$("#build").click(function(e){
		e.preventDefault();
		placeBuilding(map,sel.a.x,sel.a.y,$("#building_list").val());
		refresh();
	});
	
	$("#demolish").click(function(e){
		e.preventDefault();
		demolish(map,sel);
		refresh();
	});
	
	$("#smooth_sel").click(function(e){
		e.preventDefault();
		smoothSel(map,sel,($("#altEdges")[0].value!="" ? true :false));
		refresh();
	});
	
	$("#level_sel").click(function(e){
		e.preventDefault();
		levelSel(map,sel,($("#altEdges")[0].value!="" ? true :false));
		refresh();
	});
	
	$(".control_toggle").click(function(){
		var minned=$(".control.minimize");
		if(minned.length) {
			minned.removeClass("minimize");
		} else {
			$(".control").addClass("minimize");
		}
	});
	
	$(".mapView").click(function(){
		var $this=$(this);
		$this.toggleClass("byUser");
		setMapList();
	});
	
	$(".bldView").click(function(){
		var $this=$(this);
		$this.toggleClass("byUser");
		loadBuildingList();
	});
	
	//init game
	reloadContent();
	selUpdated();
	
	$(window).resize(function(e){
		var canvas = document.getElementById("game");
		var controls = document.getElementById("controls");
		canvas.height=$(window).height()-parseInt($(canvas).css("top").replace("px",""));
		canvas.width=$(window).width()-$(controls).width();
		refresh();
	}).load(function(e){$(window).resize()});
});


